/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.factory.Mappers;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;


/**
 *
 * @author omozegieaziegbe
 */
@Mapper
public interface PersonMapper {
    
    PersonMapper INSTANCE = Mappers.getMapper(PersonMapper.class);

//    @Mapping(source = "birthDate", target = "birthDate", dateFormat = "yyyy-MM-dd")
    @Mapping(target = "birthDate", expression = "java(map(personDto.getBirthDate()))")
    Person toPerson(PersonDto personDto);
    
    default Date map(String value) {
        if (value == null || value.isEmpty()) {
            return null;
        }
        try {
            // Customize the date format as needed
            SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
            return sdf.parse(value);
        } catch (ParseException e) {
            // Handle the exception as needed (e.g., log it or throw a custom exception)
            throw new RuntimeException("Failed to parse date: " + value, e);
        }
    }

}
